<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>CANFD Driver</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
<link href="tabs.css" rel="stylesheet" type="text/css">
</head><body>
<table width=100%>
<tr>
  <td bgcolor="black" width="1"><a href="http://www.ti.com"><img border=0 src="../../tilogo.gif"></a></td>
  <td bgcolor="red"><img src="../../titagline.gif"></td>
</tr>
</table>
<!-- Generated by Doxygen 1.8.11 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li class="current"><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&#160;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">CANFD Driver </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><p>The CANFD driver provides functionality of transferring data between CANFD peripherals. This driver does not interpret any of the data sent to or received from using this peripheral.</p>
<p>The CANFD header file should be included in an application as follows: </p><div class="fragment"><div class="line"><span class="preprocessor">#include &lt;<a class="code" href="canfd_8h.html">ti/drivers/canfd/canfd.h</a>&gt;</span></div></div><!-- fragment --><h2>Initializing the driver</h2>
<p>The CANFD Driver needs to be initialized once across the System. This is done using the <a class="el" href="group___c_a_n_f_d___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga095573d0bf132b6e5b09761c510c9b82">CANFD_init</a>. None of the CANFD API's can be used without invoking this API.</p>
<p>Once the CANFD Driver has been initialized; the bit timing can be configured using <a class="el" href="group___c_a_n_f_d___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#gaccbc797be7b2a1a6f3f75b39e8d74025">CANFD_configBitTime</a>. This APIs can be called multiple times to reconfigure bit timings.</p>
<h2>Creating the message objects</h2>
<p>Message objects are used to transmit or receive data over the CANFD peripheral. A message object is created using <a class="el" href="group___c_a_n_f_d___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga33cd186b8278b844dce2d9ea6e7c033b">CANFD_createMsgObject</a>.</p>
<h2>Sending and receiving data</h2>
<p>Data is transmitted using the <a class="el" href="group___c_a_n_f_d___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#ga9ae4a3265a6d85596c0ca0ceccb99e90">CANFD_transmitData</a>. The application will be notified when the transmit is complete if it has enabled dataInterruptEnable and registered a callback function appDataCallBack when initializing the CANFD driver.</p>
<p>If the receive interrupts are enabled using dataInterruptEnable field and a callback function appCallBack has been registered when initializing the CANFD driver, the driver notifies the application when the data has arrived. The application needs to call the <a class="el" href="group___c_a_n_f_d___d_r_i_v_e_r___e_x_t_e_r_n_a_l___f_u_n_c_t_i_o_n.html#gad471551dd1dfd104fab28ae82a6583b3">CANFD_getData</a> function to read the received data.</p>
<h2>Error and status handling</h2>
<p>The application can monitor the ECC error, Bus off error and Protocol Errors by enabling the error interrupts errInterruptEnable. The driver will call the registered callback function appErrCallBack to indicate which error fields caused the interrupt. It is up to the application to take appropriate action.</p>
<h2>Get/Set Options</h2>
<p>Helper APIs to get and set various statistics, error counters, ECC diagnostics, power down have been provided. Refer to <a class="el" href="group___c_a_n_f_d___d_r_i_v_e_r___e_x_t_e_r_n_a_l___d_a_t_a___s_t_r_u_c_t_u_r_e.html#gacece8ed652a840d768fc08e9219b56ff" title="This enumeration defines the values used to represent the GET/SET options. ">CANFD_Option</a> for more information.</p>
<h2>Limitation</h2>
<p>The CANFD driver does not support the DMA or power down.</p>
<p>The canfd/include/hw_mcanss.h has the register layer definitons for the CANFD controller module. </p>
</div></div><!-- contents -->
<hr size="1"><small>
Copyright  2018, Texas Instruments Incorporated</small>
</body>
</html>
